# Devzambra Framework

[![codecov](https://codecov.io/gh/devzambra/components/branch/master/graph/badge.svg)](https://codecov.io/gh/devzambra/components)
[![Build Status](https://travis-ci.org/devzambra/components.svg?branch=master)](https://travis-ci.org/devzambra/components)
[![npm version](https://badge.fury.io/js/dzam-components.svg)](https://badge.fury.io/js/dzam-components)

This is a custom UI Components Framework built with and for Angular. The intention is to have a set of ready-to-use components to speed up development of new apps.

A demo of the framework can be seen at [Devzambra Framework](https://devzambra.github.io/components/)

Please, note that this framework requires Angular 8.1 or higher.

## Components

| Component | Description     | Demo                                                     |
|-----------|-----------------|----------------------------------------------------------|
| Alert     | Alert component | [Docs](https://devzambra.github.io/components/) |

## Getting Started

To use any of the components of this framework, run the following command in your Angular application project.

`npm i dzam-components`

Then add the module you want to use to the imports array of your application module. For example, to use the AlertModule:

```
@NgModule({
  declarations: [AppComponent],
  imports: [BrowserModule, AlertModule],
  providers: [],
  bootstrap: [AppComponent],
  schemas: []
})
export class AppModule {}
```

Then use the component you want to use in your html template. For example, to use the AlertComponent:

`<dzam-alert></dzam-alert>`
