(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('dzam-components', ['exports', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory(global['dzam-components'] = {}, global.ng.core, global.rxjs, global.ng.common));
}(this, function (exports, core, rxjs, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DzamAlertService = /** @class */ (function () {
        function DzamAlertService() {
            this.alertMessage$ = new rxjs.Subject();
        }
        /**
         * @param {?} message
         * @return {?}
         */
        DzamAlertService.prototype.createSuccessAlert = /**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            this.alertMessage$.next(this.createAlertMessage('Success', message, 'green'));
        };
        /**
         * @param {?} message
         * @return {?}
         */
        DzamAlertService.prototype.createDangerAlert = /**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            this.alertMessage$.next(this.createAlertMessage('Danger', message, 'red'));
        };
        /**
         * @param {?} message
         * @return {?}
         */
        DzamAlertService.prototype.createWarningAlert = /**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            this.alertMessage$.next(this.createAlertMessage('Warning', message, 'darkorange'));
        };
        /**
         * @param {?} message
         * @return {?}
         */
        DzamAlertService.prototype.createInfoAlert = /**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            this.alertMessage$.next(this.createAlertMessage('Info', message, 'dodgerblue'));
        };
        /**
         * @private
         * @param {?} prefix
         * @param {?} message
         * @param {?} color
         * @return {?}
         */
        DzamAlertService.prototype.createAlertMessage = /**
         * @private
         * @param {?} prefix
         * @param {?} message
         * @param {?} color
         * @return {?}
         */
        function (prefix, message, color) {
            return { prefix: prefix, message: message, color: color };
        };
        DzamAlertService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */ DzamAlertService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function DzamAlertService_Factory() { return new DzamAlertService(); }, token: DzamAlertService, providedIn: "root" });
        return DzamAlertService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DzamAlertComponent = /** @class */ (function () {
        function DzamAlertComponent(alertService) {
            this.alertService = alertService;
            this.close$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        DzamAlertComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.alertMessage$ = rxjs.merge(this.alertService.alertMessage$, this.close$);
        };
        /**
         * @return {?}
         */
        DzamAlertComponent.prototype.closeAlert = /**
         * @return {?}
         */
        function () {
            this.close$.next();
        };
        DzamAlertComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'dzam-alert',
                        template: "<div class=\"alert\" *ngIf=\"(alertMessage$ | async) as alertMessage\" [ngStyle]=\"{background: alertMessage.color}\">\n  <span class=\"closebtn\" (click)=\"closeAlert()\">&times;</span>\n  <strong>{{ alertMessage.prefix }}!</strong> {{ alertMessage.message }}\n</div>\n",
                        styles: [".alert{padding:20px;color:#fff}.closebtn{margin-left:15px;color:#fff;font-weight:700;float:right;font-size:22px;line-height:20px;cursor:pointer;-webkit-transition:.3s;transition:.3s}.closebtn:hover{color:#000}"]
                    }] }
        ];
        /** @nocollapse */
        DzamAlertComponent.ctorParameters = function () { return [
            { type: DzamAlertService }
        ]; };
        return DzamAlertComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DzamAlertModule = /** @class */ (function () {
        function DzamAlertModule() {
        }
        DzamAlertModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        exports: [DzamAlertComponent],
                        declarations: [DzamAlertComponent],
                        providers: []
                    },] }
        ];
        return DzamAlertModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ComponentsModule = /** @class */ (function () {
        function ComponentsModule() {
        }
        ComponentsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [],
                        imports: [DzamAlertModule],
                        exports: [DzamAlertModule]
                    },] }
        ];
        return ComponentsModule;
    }());

    exports.ComponentsModule = ComponentsModule;
    exports.DzamAlertComponent = DzamAlertComponent;
    exports.DzamAlertModule = DzamAlertModule;
    exports.DzamAlertService = DzamAlertService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=dzam-components.umd.js.map
