import { Injectable, ɵɵdefineInjectable, Component, NgModule } from '@angular/core';
import { Subject, merge } from 'rxjs';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DzamAlertService {
    constructor() {
        this.alertMessage$ = new Subject();
    }
    /**
     * @param {?} message
     * @return {?}
     */
    createSuccessAlert(message) {
        this.alertMessage$.next(this.createAlertMessage('Success', message, 'green'));
    }
    /**
     * @param {?} message
     * @return {?}
     */
    createDangerAlert(message) {
        this.alertMessage$.next(this.createAlertMessage('Danger', message, 'red'));
    }
    /**
     * @param {?} message
     * @return {?}
     */
    createWarningAlert(message) {
        this.alertMessage$.next(this.createAlertMessage('Warning', message, 'darkorange'));
    }
    /**
     * @param {?} message
     * @return {?}
     */
    createInfoAlert(message) {
        this.alertMessage$.next(this.createAlertMessage('Info', message, 'dodgerblue'));
    }
    /**
     * @private
     * @param {?} prefix
     * @param {?} message
     * @param {?} color
     * @return {?}
     */
    createAlertMessage(prefix, message, color) {
        return { prefix, message, color };
    }
}
DzamAlertService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ DzamAlertService.ngInjectableDef = ɵɵdefineInjectable({ factory: function DzamAlertService_Factory() { return new DzamAlertService(); }, token: DzamAlertService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DzamAlertComponent {
    /**
     * @param {?} alertService
     */
    constructor(alertService) {
        this.alertService = alertService;
        this.close$ = new Subject();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.alertMessage$ = merge(this.alertService.alertMessage$, this.close$);
    }
    /**
     * @return {?}
     */
    closeAlert() {
        this.close$.next();
    }
}
DzamAlertComponent.decorators = [
    { type: Component, args: [{
                selector: 'dzam-alert',
                template: "<div class=\"alert\" *ngIf=\"(alertMessage$ | async) as alertMessage\" [ngStyle]=\"{background: alertMessage.color}\">\n  <span class=\"closebtn\" (click)=\"closeAlert()\">&times;</span>\n  <strong>{{ alertMessage.prefix }}!</strong> {{ alertMessage.message }}\n</div>\n",
                styles: [".alert{padding:20px;color:#fff}.closebtn{margin-left:15px;color:#fff;font-weight:700;float:right;font-size:22px;line-height:20px;cursor:pointer;-webkit-transition:.3s;transition:.3s}.closebtn:hover{color:#000}"]
            }] }
];
/** @nocollapse */
DzamAlertComponent.ctorParameters = () => [
    { type: DzamAlertService }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DzamAlertModule {
}
DzamAlertModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [DzamAlertComponent],
                declarations: [DzamAlertComponent],
                providers: []
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ComponentsModule {
}
ComponentsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [],
                imports: [DzamAlertModule],
                exports: [DzamAlertModule]
            },] }
];

export { ComponentsModule, DzamAlertComponent, DzamAlertModule, DzamAlertService };
//# sourceMappingURL=dzam-components.js.map
